lparameters tcClass, ;
	tcLibrary, ;
	tnOrder
local lcClass

* Open the report builder table.

use ReportBuilder

* Renumber the orders for existing filter records as necessary.

replace Fltr_Ordr with transform(val(Fltr_Ordr) + 1) for Rec_Type = 'F' and ;
	val(Fltr_Ordr) >= tnOrder

* If the specified filter isn't already there, add a record for it. Otherwise,
* update the order.

lcClass = padr(upper(tcClass), len(Hndl_Class))
locate for Rec_Type = 'F' and upper(Hndl_Class) == lcClass
if not found()
	insert into ReportBuilder ;
			(Rec_Type, ;
			Hndl_Class, ;
			Hndl_Lib) ;
		values ;
			('F', ;
			tcClass, ;
			tcLibrary)
endif not found()
replace Fltr_Ordr with transform(tnOrder)

* Clean up and exit.

use
