*** we may get this from source H file or FOXPRO.H too:

#define LISTENER_DEVICE_TYPE_EMF				100
#define LISTENER_DEVICE_TYPE_TIFF				101
#define LISTENER_DEVICE_TYPE_JPEG				102
#define LISTENER_DEVICE_TYPE_GIF				103
#define LISTENER_DEVICE_TYPE_PNG				104
#define LISTENER_DEVICE_TYPE_BMP				105
#define LISTENER_DEVICE_TYPE_MULTI_PAGE_TIFF	201


**********************
* these come from XSource FRX.H because they may be in FOXPRO.H at some point:

*-- FRX object Protection flags.
*-- These are bit numbers or powers of 2.
*-- not numeric values. They are stored 
*-- in the ORDER column as a character 
*-- representation of the sum of their 
*-- binary equivalent values.)
#define FRX_PROTECT_OBJECT_LOCK             0
#define FRX_PROTECT_OBJECT_HIDE             1
#define FRX_PROTECT_OBJECT_NO_DELETE        2
#define FRX_PROTECT_OBJECT_NO_EDIT          3
#define FRX_PROTECT_OBJECT_NO_SELECT        6
#define FRX_PROTECT_BAND_NO_ADD             4
#define FRX_PROTECT_BAND_NO_REMOVE          5
#define FRX_PROTECT_BAND_NO_RESIZE         14
#define FRX_PROTECT_REPORT_NO_PREVIEW       7
#define FRX_PROTECT_REPORT_NO_OPTBAND       8
#define FRX_PROTECT_REPORT_NO_GROUP         9
#define FRX_PROTECT_REPORT_NO_VARIABLES    10
#define FRX_PROTECT_REPORT_NO_PAGESETUP    11
#define FRX_PROTECT_REPORT_NO_MULTISELECT  12
#define FRX_PROTECT_REPORT_NO_DATAENV      13

*-- FRX report structure constants
*-- FRX PLATFORM column values
#define FRX_PLATFORM_WINDOWS                "WINDOWS"

*-- FRX OBJTYPE column values
#define FRX_OBJTYP_COMMENT                  0
#define FRX_OBJTYP_REPORTHEADER             1
#define FRX_OBJTYP_WORKAREA                 2
#define FRX_OBJTYP_INDEX                    3
#define FRX_OBJTYP_RELATION                 4
#define FRX_OBJTYP_LABEL                    5
#define FRX_OBJTYP_LINE                     6
#define FRX_OBJTYP_RECTANGLE                7
#define FRX_OBJTYP_FIELD                    8
#define FRX_OBJTYP_BAND                     9
#define FRX_OBJTYP_GROUP                   10
#define FRX_OBJTYP_PICTURE                 17
#define FRX_OBJTYP_VARIABLE                18
#define FRX_OBJTYP_PDRIVER                 21
#define FRX_OBJTYP_FONTRES                 23
#define FRX_OBJTYP_DATAENV                 25
#define FRX_OBJTYP_DATAOBJ                 26

*-- FRX OBJCODE column values
#define FRX_OBJCOD_TITLE                    0
#define FRX_OBJCOD_PAGEHEADER               1
#define FRX_OBJCOD_COLHEADER                2
#define FRX_OBJCOD_GROUPHEADER              3
#define FRX_OBJCOD_DETAIL                   4
#define FRX_OBJCOD_GROUPFOOTER              5
#define FRX_OBJCOD_COLFOOTER                6
#define FRX_OBJCOD_PAGEFOOTER               7
#define FRX_OBJCOD_SUMMARY                  8
#define FRX_OBJCOD_DETAILHEADER             9
#define FRX_OBJCOD_DETAILFOOTER            10
#define FRX_OBJCOD_RECTANGLE                4
#define FRX_OBJCOD_REPORTHEADER            53
#define FRX_OBJCOD_OTHER                    0

*-- FRX PENSIZE column values
#define FRX_PENSIZE_HAIRLINE                0
#define FRX_PENSIZE_1POINTS                 1
#define FRX_PENSIZE_2POINTS                 2
#define FRX_PENSIZE_4POINTS                 4
#define FRX_PENSIZE_6POINTS                 6

*-- FRX PENPAT column values
#define FRX_PENPAT_NONE                     0 
#define FRX_PENPAT_DOTTED                   1
#define FRX_PENPAT_DASHED                   2
#define FRX_PENPAT_DASHDOT                  3
#define FRX_PENPAT_DASHDOTDOT               4
#define FRX_PENPAT_SOLID                    8

*-- FRX FILLPAT column values
#define FRX_FILLPAT_NONE                    0
#define FRX_FILLPAT_SOLID                   1
#define FRX_FILLPAT_HORIZONTAL              2
#define FRX_FILLPAT_VERTICAL                3
#define FRX_FILLPAT_LEFTDIAGONAL            4
#define FRX_FILLPAT_RIGHTDIAGONAL           5
#define FRX_FILLPAT_GRID                    6
#define FRX_FILLPAT_CROSSHATCH              7

*-- FRX FONTSTYLE column flags (sum to obtain value)
#define FRX_FONTSTYLE_NORMAL                0
#define FRX_FONTSTYLE_BOLD                  1
#define FRX_FONTSTYLE_ITALIC                2
#define FRX_FONTSTYLE_UNDERLINED            4
#define FRX_FONTSTYLE_STRIKETHROUGH       128 

*-- FRX MODE column flags (sum to obtain value)
#define FRX_MODE_OPAQUE                     0
#define FRX_MODE_TRANSPARENT                1
#define FRX_MODE_LTR                        0  && Left-to-Right
#define FRX_MODE_RTL                        2  && Right-to-Left
#define FRX_MODE_CONTEXT                    4  

*-- FRX RULER column / measurement units
#define FRX_RULER_OFF                       0
#define FRX_RULER_FRUS                      0
#define FRX_RULER_INCHES                    1
#define FRX_RULER_METRIC                    2
#define FRX_RULER_PIXELS                    3
#define FRX_RULER_CHARACTERS                4
#define FRX_RULER_SYSDEFAULT                5

*-- FRX RULERLINES column values
#define FRX_RULERLINES_OFF                  0
#define FRX_RULERLINES_ON                   1

*-- FRX GENERAL column values for RECTANGLE/SHAPEs
#define FRX_PICTUREMODE_CLIP                0
#define FRX_PICTUREMODE_SCALE_KEEP_SHAPE    1
#define FRX_PICTUREMODE_SCALE_STRETCH       2

*-- FRX SPACING column, line spacing values for LABEL objects:
#define FRX_SPACING_SINGLE                  0
#define FRX_SPACING_ONE_POINT_FIVE          1
#define FRX_SPACING_DOUBLE                  2

*-- FRX Field object justification (OFFSET column)
#define FRX_JUSTIFICATION_LEFT              0
#define FRX_JUSTIFICATION_RIGHT             1
#define FRX_JUSTIFICATION_CENTER            2

*-- FRX Picture object source type (OFFSET column)
#define FRX_PICTURE_SOURCE_FILENAME         0  && stored in PICTURE column
#define FRX_PICTURE_SOURCE_GENERAL          1  && stored in NAME    column
#define FRX_PICTURE_SOURCE_EXPRESSION       2  && stored in NAME    column

*-- FRX TOTALTYPE column calculation types
#define FRX_TOTALTYPE_NONE                  0
#define FRX_TOTALTYPE_COUNT                 1
#define FRX_TOTALTYPE_SUM                   2
#define FRX_TOTALTYPE_AVERAGE               3
#define FRX_TOTALTYPE_LOWEST                4
#define FRX_TOTALTYPE_HIGHEST               5
#define FRX_TOTALTYPE_STDDEV                6
#define FRX_TOTALTYPE_VARIANCE              7

*-- FRX RESETTOTAL column values 
#define FRX_RESETTOTAL_ENDOFREPORT          1
#define FRX_RESETTOTAL_ENDOFPAGE            2
#define FRX_RESETTOTAL_ENDOFCOLUMN          3
#define FRX_RESETTOTAL_GROUP_OFFSET         5   && add to group index
#define FRX_RESETTOTAL_DETAIL_OFFSET        79  && add to detail band index
**********************





**** THESE WERE ALL TAKEN FROM SFREPOBJ.H

*** THESE WERE GIVEN BETTER NAMES THAN cnREPOBJ_CODE_bandname

* Report object codes.

#define cnBAND_TITLE					 0
#define cnBAND_PGHEADER					 1
#define cnBAND_COLHEADER				 2
#define cnBAND_GPHEADER					 3
#define cnBAND_DETAIL					 4
#define cnBAND_GPFOOTER					 5
#define cnBAND_COLFOOTER				 6
#define cnBAND_PGFOOTER					 7
#define cnBAND_SUMMARY					 8
#define cnBAND_HEADER					53

* Totaling types.

#define ccTOTAL_NONE                'N'
#define cnTOTAL_NONE                0
#define ccTOTAL_COUNT               'C'
#define cnTOTAL_COUNT               1
#define ccTOTAL_SUM                 'S'
#define cnTOTAL_SUM                 2
#define ccTOTAL_AVERAGE             'A'
#define cnTOTAL_AVERAGE             3
#define ccTOTAL_LOWEST              'L'
#define cnTOTAL_LOWEST              4
#define ccTOTAL_HIGHEST             'H'
#define cnTOTAL_HIGHEST             5
#define ccTOTAL_STDDEV              'D'
#define cnTOTAL_STDDEV              6
#define ccTOTAL_VARIANCE            'V'
#define cnTOTAL_VARIANCE            7

* Object alignment constants.

#define ccALIGN_LEFT                'Left'
#define ccALIGN_CENTER              'Center'
#define ccALIGN_RIGHT               'Right'
#define cnALIGN_LEFT                0
#define cnALIGN_RIGHT               1
#define cnALIGN_CENTER              2

* Modes.

#define cnMODE_TRANSPARENT          1
#define cnMODE_OPAQUE               2

* Report font style constants.

#define cnSTYLE_NORMAL              0
#define cnSTYLE_BOLD                1
#define cnSTYLE_BOLD_BIT            0
#define cnSTYLE_ITALIC              2
#define cnSTYLE_ITALIC_BIT          1
#define cnSTYLE_UNDERLINE           4
#define cnSTYLE_UNDERLINE_BIT       2

* Report measurement units.

#define ccUNITS_CHARACTERS          'C'
#define ccUNITS_INCHES              'I'
#define ccUNITS_CENTIMETERS         'M'

* Report object types.

#define cnREPOBJ_HEADER              1
#define cnREPOBJ_TEXT                5
#define cnREPOBJ_LINE                6
#define cnREPOBJ_BOX                 7
#define cnREPOBJ_FIELD               8
#define cnREPOBJ_BAND                9
#define cnREPOBJ_IMAGE              17
#define cnREPOBJ_VARIABLE           18
#define cnREPOBJ_FONT               23
#define cnREPOBJ_DATA_ENVIRONMENT   25
#define cnREPOBJ_DATA_OBJECT        26

* Report object codes.

#define cnREPOBJ_CODE_TITLE          0
#define cnREPOBJ_CODE_PGHEADER       1
#define cnREPOBJ_CODE_COLHEADER      2
#define cnREPOBJ_CODE_GPHEADER       3
#define cnREPOBJ_CODE_DETAIL         4
#define cnREPOBJ_CODE_GPFOOTER       5
#define cnREPOBJ_CODE_COLFOOTER      6
#define cnREPOBJ_CODE_PGFOOTER       7
#define cnREPOBJ_CODE_SUMMARY        8
#define cnREPOBJ_CODE_HEADER        53

* Report band names (in upper case).

#define ccBAND_TITLE                'TITLE'
#define ccBAND_PAGE_HEADER          'PAGE HEADER'
#define ccBAND_COLUMN_HEADER        'COLUMN HEADER'
#define ccBAND_GROUP_HEADER         'GROUP HEADER'
#define ccBAND_DETAIL               'DETAIL'
#define ccBAND_GROUP_FOOTER         'GROUP FOOTER'
#define ccBAND_COLUMN_FOOTER        'COLUMN FOOTER'
#define ccBAND_PAGE_FOOTER          'PAGE FOOTER'
#define ccBAND_SUMMARY              'SUMMARY'

* Report object types (in upper case).

#define ccOBJECT_FIELD              'FIELD'
#define ccOBJECT_TEXT               'TEXT'
#define ccOBJECT_LINE               'LINE'
#define ccOBJECT_IMAGE              'IMAGE'
#define ccOBJECT_BOX                'BOX'

* Object positions options.

#define cnPOSITION_FLOAT            0
#define cnPOSITION_TOP              1
#define cnPOSITION_BOTTOM           2

* Other constants.

#define cnPOINTS_PER_INCH           72

* cnVERTICAL_FUDGE is a "fudge factor" used so objects are correctly placed.

#define cnVERTICAL_FUDGE            2

* cnWIDTH_FUDGE is a "fudge factor" used so field objects are correctly sized.

#define cnWIDTH_FUDGE               0.23

* cnTXTWIDTH_FUDGE is a "fudge factor" applied to values returned by TXTWIDTH().

#define cnTXTWIDTH_FUDGE            1.044

* cnPEN_RED_FUDGE is a "fudge factor" for the PEN_RED value in an FRX.

#define cnPEN_RED_FUDGE             4

* cnREPORT_UNITS is the number of report units (a value used for all
* measurements inside the FRX) per inch

#define cnREPORT_UNITS              10000

* cnFACTOR is the number of report units per pixel. It's calculated as report
* units per inch (10,000) divided by pixels per inch (96). 10000/96 = 104.166.

#define cnFACTOR                    104.166            

* cnBAND_HEIGHT is the height of the band separator, which is 20 pixels or
* 2083.333 report units.

#define cnBAND_HEIGHT               2083.333

* cnGROUP_OFFSET is what to add to a group number for group breaks.

#define cnGROUP_OFFSET              5

* ccAVG_CHAR is the "average" character in a font used to determine object
* sizing.

#define ccAVG_CHAR                  'N'

* cnPORTRAIT_WIDTH, cnLANDSCAPE_WIDTH, and cnLANDLEGAL_WIDTH are the widths of
* portrait, landscape, and landscape on legal paper reports, respectively, in
* report units (80000 = 8", 105000 = 10.5", 140000 = 14", which is for 8 1/2"
* x 11" paper, less laser printer margins). Change these to use a different
* paper size. cnPRINTER_MARGIN is the printer margin (0.25" per side = 0.5").

#define cnDEFAULT_REPORT_LENGTH       11
#define cnDEFAULT_REPORT_WIDTH        8.5
#define cnDEFAULT_PRTINFO_POINTONEMM  254
#define cnDEFAULT_PRTINFO_MM          25.4
#define cnPORTRAIT_WIDTH               80000
#define cnLANDSCAPE_WIDTH             105000
#define cnLANDLEGAL_WIDTH             140000
#define cnPRINTER_MARGIN              0.5
